.586
.model flat, stdcall
option casemap:none
include windows.inc
include kernel32.inc
includelib kernel32.lib
include user32.inc
includelib user32.lib
include wsock32.inc
includelib wsock32.lib

;***************************************************************************************************

WinMain proto
WndProc proto hwnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

scan proto
geterror proto

;***************************************************************************************************

WIN_WIDTH       equ 320
WIN_HEIGHT      equ 240

IDPOKER         equ 5001

WM_SOCKET       equ 678

;***************************************************************************************************

.data
ClassName   db "socketumi",0
AppName     db "Strange",0

buttonClass db "BUTTON",0
fmt_        db "code=%lu",0

poke        db "Poke!",0
target      db "yahoo.com",0
woot        db "Connected.",0
error       db "Random ERROR!!",0

.data?
hInstance   HINSTANCE   ?
hWnd        HWND        ?

wsadata     WSADATA     <?>

hPoker      HANDLE      ?
sock        DWORD       ?

.code
start:
    invoke GetModuleHandle, NULL
    mov hInstance,eax
    invoke WinMain
    invoke ExitProcess, eax

;***************************************************************************************************

WinMain proc
    LOCAL wc:WNDCLASSEX
    LOCAL msg:MSG
    mov [wc].cbSize,SIZEOF wc
    mov [wc].style,CS_HREDRAW or CS_VREDRAW
    mov [wc].lpfnWndProc,OFFSET WndProc
    mov eax,hInstance
    mov [wc].hInstance,eax
    invoke LoadIcon, NULL,IDI_APPLICATION
    mov [wc].hIcon,eax
    invoke LoadCursor, NULL,IDC_ARROW
    mov [wc].hCursor,eax
    mov [wc].hbrBackground,COLOR_WINDOW+1
    mov [wc].lpszClassName,OFFSET ClassName
    xor eax,eax
    mov [wc].cbClsExtra,eax
    mov [wc].cbWndExtra,eax
    mov [wc].lpszMenuName,eax
    mov [wc].hIconSm,eax
    invoke RegisterClassEx, ADDR wc
    invoke CreateWindowEx, NULL,ADDR ClassName,ADDR AppName,WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,CW_USEDEFAULT,WIN_WIDTH,WIN_HEIGHT,NULL,NULL,hInstance,NULL
    .IF (eax)
        push ebx
        mov hWnd,eax
        invoke ShowWindow, hWnd,SW_SHOWDEFAULT
        invoke UpdateWindow, hWnd
        lea ebx,[msg]
        assume ebx:ptr MSG
        .WHILE TRUE
            xor eax,eax
            invoke GetMessage, ebx,eax,eax,eax
            .BREAK .IF(!eax)
            invoke TranslateMessage, ebx
            invoke DispatchMessage, ebx
        .ENDW
        mov eax,[ebx].wParam
        assume ebx:nothing
        pop ebx
    .ENDIF
    ret
WinMain endp

WndProc proc hwnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
    mov eax,uMsg
;-- WM_SOCKET --------------------------------------------------------------------------------------
    .IF (eax==WM_SOCKET)
        mov eax,lParam
        .if ax == FD_CONNECT
            shr eax,16
            .if eax == NULL
                invoke MessageBox,hwnd,ADDR woot,ADDR target,MB_OK
            .else
                invoke geterror
            .endif
        .endif
;-- WM_COMMAND -------------------------------------------------------------------------------------
    .ELSEIF (eax==WM_COMMAND)
        ;lParam is hWndCtl
        mov eax,wParam
        mov edx,eax
        and eax,0ffffh      ;item/control/accel ID
        shr edx,16          ;notification code (0=menu; 1=accelerator)
        .IF (edx==BN_CLICKED)
            .IF (eax==IDPOKER)
                invoke scan
            .ENDIF
        .ENDIF
;-- WM_CREATE --------------------------------------------------------------------------------------
    .ELSEIF (eax==WM_CREATE)
        invoke CreateWindowEx, NULL,ADDR buttonClass,ADDR poke,WS_CHILD or WS_VISIBLE or BS_DEFPUSHBUTTON,10,10,120,50,hwnd,IDPOKER,hInstance,NULL
        mov hPoker,eax

        invoke WSAStartup, 101h,ADDR wsadata

;-- WM_DESTROY -------------------------------------------------------------------------------------
    .ELSEIF (eax==WM_DESTROY)
        invoke PostQuitMessage, NULL
;-- default ----------------------------------------------------------------------------------------
    .ELSE
        invoke DefWindowProc, hwnd,uMsg,wParam,lParam
        ret
    .ENDIF
    xor eax,eax
    ret
WndProc endp

;***************************************************************************************************

scan proc uses edi
    invoke socket,AF_INET,SOCK_STREAM,0
    .if eax != INVALID_SOCKET
        mov sock,eax
    .else
        invoke MessageBox,hWnd,ADDR error,addr error,MB_ICONERROR
    .endif

    invoke WSAAsyncSelect,sock,hWnd,WM_SOCKET,FD_CONNECT
    .if eax==SOCKET_ERROR
        invoke MessageBox,hWnd,ADDR error,addr error,MB_ICONERROR
    .endif

    ;------------------------------------
    ;invoke GetWindowTextLength,hbox1
    ;inc eax
    ;invoke GetWindowText,hbox1,addr target,eax
    ;------------------------------------

    assume edi:ptr sockaddr_in
    mov [edi].sin_family, AF_INET
    invoke inet_addr,addr target
    invoke htons,80
    mov [edi].sin_port,ax

    invoke inet_addr,addr target
    .if eax==INADDR_NONE
        invoke gethostbyname,addr target
        .if eax != NULL
            mov eax, (hostent ptr [eax]).h_list
            mov eax, [eax]
            mov eax, [eax]
        .endif
    .endif

    mov [edi].sin_addr,eax

    invoke connect,sock,edi,sizeof sockaddr_in
    .if eax==SOCKET_ERROR
        invoke WSAGetLastError
        .if eax != WSAEWOULDBLOCK
            invoke geterror
            jmp @F
        .endif
    .else
        invoke closesocket,sock
        .if eax==SOCKET_ERROR
            invoke geterror
            jmp @F
        .endif
    .endif
  @@:
    assume edi:nothing
    ret
scan endp

geterror proc uses edi
    assume edi:DWORD
    ;invoke dwtoa,eax,edi
    invoke wsprintf, edi,ADDR fmt_,eax
    invoke MessageBox,hWnd,edi,addr error,MB_ICONERROR
    assume edi:nothing
    ret
geterror endp

end start
